#!/usr/bin/perl -w
use strict;
our %s;

# perl -C31 -we "
BEGIN{
  binmode STDOUT, q(:raw :utf8);
  my @n  = map chr, (0x24ea,0x2460..0x2473,0x3251..0x325f,0x32b1..0x32bf);
  my @pn  = map chr, (0x30,0x2474..0x2487);
  my @dbl= map chr, (0x2030,0x24f5..0x24fe); 
  my @A  = map chr, (0x24b6..0x24cf); 
  my @a  = map chr, (0x24d0..0x24e9);
  my @pa  = map chr, (0x249c..0x24b5);
  #print for @n,@dbl,@a,@A,@pn,@pa;
  #print "\n";
  my %seen_pref = qw(00 1);

  sub hex2($) {
    my($in, $pad, $P) = (shift, ''); 
    $in =~ s/^(\d\w)// and $P = $1; 	# Treat 6 hexdigit as 4, if possible
    $seen_pref{$P}++ or $pad = "===================== $P\r\n";
    $in =~ s/^(?=50|[0-4])(\d\d)$/$n[$1]/; 
    $in =~ s/^(\d)0$/$dbl[$1]/; 
    $in =~ s/^([a-f])0$/$A[ord(lc $1)-ord(q(a))]/i; 
    $in =~ s/^0([a-f])$/$a[ord(lc $1)-ord(q(a))]/i; 
    $in =~ s/^.([a-f])$/$pa[ord(lc $1)-ord(q(a))]/i; 
    $in =~ s/^.(\d)$/$pn[$1]/; 
    "$pad$in"
  }
}

#print hex2 sprintf '%02x', $_ for 0..255;


next unless /^Encoding:\s+[-\d]+\s+(\d+)/; $s{sprintf '%04x', $1>>8}{chr $1}++;

END{ 
  for my $CC (sort keys %s) {
    my $c;
    print hex2 $CC;
    for my $C (sort keys %{$s{$CC}}) {print q( ) if $C =~ /\p{NonSpacingMark}/; print $C; print qq(\r\n ) unless ++$c % 77;}
    print "\r\n";
  }
}